% Descripcin :  gsinc2.m
%
% Este bloque S-function actua como una subrutina ejecutada en Matlab.
% no existen variables continuas (derivadas)
% se evalua la salida como:
%  y = f(u)
%   u : entradas
%   y : Salidas   son  devueltas en sys
%
% Objetivo :
%   Representar el generador sincrono

function [sys, x0 ]=gsinc2(t,x,u,flag,Ra,Xd,Xq,Xdp)

% Parmetros :
%  Ra  :  Resistencia del estator
%  Xd  :  Reactancia de eje d
%  Xq  :  Reactancia de eje q
%  Xdp :  Reactancia Xd'
% Variables de Salida
%  sys(1) = i'd
%  sys(2) = i'q
%  sys(3) = El
% Variables de entrada:
%  u(1) = u'd
%  u(2) = u'q
%  u(3) = E'q

if flag==3
   %salida del sistema
   A=[-Ra Xq ; -Xdp -Ra];
   udq=[u(1) u(2)]';
   B=[0 u(3)]';
   Idq=inv(A)*(udq-B);
   El=u(3)+(Xd-Xdp)*Idq(1);
   sys =[Idq(1) Idq(2) El];

   elseif flag==0
         %parametros y condiciones iniciales     
         %1ro: Numero de estados continuos
         %2do: Numero estados discretos
         %3ro: Numero de salidas  X
         %4to: Numero de entradas U
         % los otros cero
         sys=[0;0;3;3;0;1];
         x0=[];        
      else
         sys=[];
 end
