% Descripcin :   retrasador.m
%
% Este bloque S-function actua como una subrutina ejecutada en Matlab.
% no existen variables continuas (derivadas)
% se evalua la salida como:
% y = f(u)
%  u : entradas
%  y : Salidas   son  devueltas en sys
%
% Objetivo :
%  Producir un retraso en la actuacin del LTC
%
function [sys, x0 ]=retrasador(t,x,u,flag,DB,Tdo)
global tlast contador contadorb
%Parmetros 
% DB      : Zona Muerta, variacion de tensin que detecta
% Tdo      : Retraso inicial
%Variables de Salida
% sys(1) = b       1:  Ordena actuacion del motor que cambia tomas (sube)
%                 -1:  Ordena actuacion del motor que cambia tomas (baja)
%                  0:  No actuacion del motor
%Variables de entrada:
% u(1) : Error de variacin de tensin   =  Uref - Umedido    
% u(2) : e          +1: Incrementar toma
%                   -1: decrementar toma
%                    0: Mantener toma
if flag==3
   %salida del sistema
   if t==0 
      tlast=0;
      contador=0;
      contadorb=0;
   end
   if u(1)== 0
      Td=Tdo;
    else
    Td=Tdo/abs(u(1)/DB);
   end
if u(2)==0
      sys(1)=0;
      contador=0;
      contadorb=0;
   elseif u(2)==1
      contador=contador+(t-tlast);
      contadorb=0;
      if contador>Td 
         sys(1)=1;
         contador=0;
         contadorb=0;
      else
         sys(1)=0;
      end
      elseif u(2)==-1
      contadorb=contadorb+(t-tlast);
      contador=0;
      if contadorb>Td 
         sys(1)=-1; 
         contadorb=0;
         contador=0;
      else
         sys(1)=0;
      end
   end
    tlast=t;
   elseif flag==0
         %parametros y condiciones iniciales
         %1ro: Nmero de estados continuos
         %2do: Nmero estados discretos
         %3ro: Nmero de salidas  X
         %4to: Nmero de entradas U
         %Los otros cero
         sys=[0;0;1;2;0;1];
         x0=[];        
      else
         sys=[];
 end
