% Descripcin :   tomas.m
%
% Este bloque S-function actua como una subrutina ejecutada en Matlab.
% no existen variables continuas (derivadas)
% se evalua la salida como:
%  y = f(u)
%   u : entradas
%   y : Salidas   son  devueltas en sys
%
% Objetivo :
%  Cambiar la toma del LTC de una posicin a otra  

function [sys, x0 ]=tomas(t,x,u,flag,incrtoma,tinic,tmin,tmax)
global  toma
% Parmetros:
%  incrtoma: incremento de tomas (delta_a)
%  tinic   : Posicin inicial de la toma
%  tmin    : Posicion minima de la toma
%  tmax    : Posicion mxima de la toma
% Variables de Salida
%  sys(1) : Posicin de la toma entre [-10,10] 
%  sys(2) : Relacin de transformacin actualizada
% Variables de entrada:
%  u(1) : Salida retrasador (b)   -1: Incrementar toma
%                               +1: decrementar toma
%                                0: Mantener toma  (no actua motor)
if t==0 
   toma=tinic;     %Posicin inicial de la toma entre [-10,10] de uno en uno 
end
if flag==3
% salida del sistema
  if u(1)==-1  delta_n=1;end
  if u(1)==0  delta_n=0; end 
  if u(1)==1   delta_n=-1; end
  toma=toma+delta_n;
  if toma > tmax
     toma=tmax;
  elseif toma<tmin
     toma=tmin;
  end
  sys(1)=toma;
  sys(2)=1+toma*incrtoma
elseif flag==0
         %parmetros y condiciones iniciales
         %1ro: Nmero de estados continuos
         %2do: Nmero estados discretos
         %3ro: Nmero de salidas  X
         %4to: Nmero de entradas U
         % los otros cero
         sys=[0;0;2;1;0;1];
         x0=[]; toma=tinic;       
      else
         sys=[];
 end
